| API Documentation |  |

- MAIN PAGE
- NAMESPACES
- CLASSES

Public Member Functions | List of all members
nkGraphics::ResourceDeclAugmentCallback Class Reference

A callback called whenever a resource is being processed, during a save or load of resource set. More...

## Public Member Functions
| ResourceDeclAugmentCallback () noexcept
virtual | ~ResourceDeclAugmentCallback ()
virtual void | onCamera (Camera *camera, nkExport::Node *rootNode)
virtual void | onMesh (Mesh *mesh, nkExport::Node *rootNode)
virtual void | onRenderQueue (RenderQueue *renderQueue, nkExport::Node *rootNode)
virtual void | onShader (Shader *shader, nkExport::Node *rootNode)
virtual void | onTexture (Texture *texture, nkExport::Node *rootNode)

## Detailed Description

A callback called whenever a resource is being processed, during a save or load of resource set.

This enables to export and load additional data from an application on resources.
Callbacks get called :

- When loading a resource. Resource is set up with what the component imports by default, the rootNode is the tree used to import the resource, as loaded.
- When saving a resource. Resource has already populated the rootNode with what the component exports by default.< /li>

External code can then read application specific fields from the tree when loading, or add information to the tree while saving.

## Constructor & Destructor Documentation

## ◆ ResourceDeclAugmentCallback()

nkGraphics::ResourceDeclAugmentCallback::ResourceDeclAugmentCallback | ( |  | ) |
| noexcept

Constructor.

## ◆ ~ResourceDeclAugmentCallback()

virtual nkGraphics::ResourceDeclAugmentCallback::~ResourceDeclAugmentCallback | ( |  | ) |
| virtual

Destructor.

## Member Function Documentation

## ◆ onCamera()

virtual void nkGraphics::ResourceDeclAugmentCallback::onCamera | ( | Camera * | camera,
|  | nkExport::Node * | rootNode
| ) |  |
| virtual

Called when a camera is being processed.

Parameters

  camera | The camera being processed.
  rootNode | The tree attached to the resource.

## ◆ onMesh()

virtual void nkGraphics::ResourceDeclAugmentCallback::onMesh | ( | Mesh * | mesh,
|  | nkExport::Node * | rootNode
| ) |  |
| virtual

Called when a mesh is being processed.

Parameters

  mesh | The mesh being processed.
  rootNode | The tree attached to the resource.

## ◆ onRenderQueue()

virtual void nkGraphics::ResourceDeclAugmentCallback::onRenderQueue | ( | RenderQueue * | renderQueue,
|  | nkExport::Node * | rootNode
| ) |  |
| virtual

Called when a render queue is being processed.

Parameters

  renderQueue | The render queue being processed.
  rootNode | The tree attached to the resource.

## ◆ onShader()

virtual void nkGraphics::ResourceDeclAugmentCallback::onShader | ( | Shader * | shader,
|  | nkExport::Node * | rootNode
| ) |  |
| virtual

Called when a shader is being processed.

Parameters

  shader | The shader being processed.
  rootNode | The tree attached to the resource.

## ◆ onTexture()

virtual void nkGraphics::ResourceDeclAugmentCallback::onTexture | ( | Texture * | texture,
|  | nkExport::Node * | rootNode
| ) |  |
| virtual

Called when a texture is being processed.

Parameters

  texture | The texture being processed.
  rootNode | The tree attached to the resource.

The documentation for this class was generated from the following file:

- Documentation/Headers/NilkinsGraphics/Resources/ResourceDeclAugmentCallback.h